# Copyright (c) 2010 Dario Guerrero & Almudena Bocinos
# 
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# 'Software'), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
# 
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


$: << File.join(File.dirname(__FILE__),File.basename(__FILE__,File.extname(__FILE__)))		

v='0.0.0'
begin
  s=`blastn -version`
  v=s.split("\n").first.split(' ').last.gsub('+','')

rescue Exception => e
  raise "Blast not installed"
end

if Gem::Version.new(v) < Gem::Version.new('2.2.28')
    puts "Blast #{v} is older than 2.2.28+, please use scbi_blast version 0.0.37 or upgrade your blast to 2.2.28 or greater"
    exit
end


require 'batch_blast'
require 'dust_masker'
require 'blast_query'
# require 'blast_xml_result'
require 'blast_result'
require 'blast_simplexml_result'
require 'blast_streamxml_result'
require 'blast_hit'
require 'blast_table_result'

module ScbiBlast
   VERSION = '0.0.43'
end


